// $Id: FocusCharPixels.c,v 1.1 1997/03/25 10:18:43 yotam Exp $

#include "FocusCharPixels.h"
#include "debug.h"

////////////////////////////////////////////////////////////////////////
static bool
within(int x, int l, int h)
{
   return(l <= x && x <= h);
} // withinGeLt


////////////////////////////////////////////////////////////////////////
const char*
FocusCharPixels::probeMessage(int x, int y, int w, int h, int pad) const
{
   DPR0("probeMessage(" << x << ", " << y << ")");
   const char  *msg = 0; // "Outside";

   if (within(x, bbl, bbl + em) && !within(y, pad + 1, h - pad - 1))
   {
      msg = "quad = em";
   }
   else if (within(y, exTop, bbm) && !within(x, pad + 1, w - pad - 1))
   {
      msg = "ex-Height";
   }
   else if (within(x, bbl, bbr))
   {
      if (within(y, bbh, bbm))
      {
         msg = "Inside above base";
      }
      else if (within(y, bbm, bbd))
      {
         msg = "Inside below base";
      }
   }

   if (msg == 0)
   {
      if (within(x, leftStretch, leftSpace))
      {
         msg = "Space stretch";
      }
      else if (within(x, leftSpace, leftShrink))
      {
         msg = "Space shrink";
      }
      else if (within(x, leftShrink + 1, bbl - 1))
      {
         msg = "Less than shrinked space";
      }
      else if (within(x, bbr + 1, itCor))
      {
         msg = "Italic correction";
      }
      else if (within(x, bbr + 1, rightShrink))
      {
         msg = "Less than shrinked space";
      }
      else if (within(x, rightShrink + 1, rightSpace - 1))
      {
         msg = "Space shrink";
      }
      else if (within(x, rightSpace + 1, rightStretch - 1))
      {
         msg = "Space stretch";
      }

      if (extSpcLeft)
      {
         if (within(x, extSpcLeft, leftStretch))
         {
            msg = "End of sentence space";
         }
      }
      if (msg == 0)
      {
         msg = "Outside";
      }
   }

   return(msg);
} // FocusCharPixels::probeMessage
