// $Id: FocusCharPixels.h,v 1.1 1997/03/25 10:18:43 yotam Exp $
// place holders for special pixel values 
// for drawing focus-char.
#ifndef fOcUschArpIxEls
#define fOcUschArpIxEls

class FocusCharPixels
{
 public:
   FocusCharPixels() {};
   virtual ~FocusCharPixels() {};

   const char*  probeMessage(int x, int y, int w, int h, int pad) const;
   
   // Bounding box.  bbl<bbr ^ bbh<bbm<=bbd
   unsigned  bbl;    // left
   unsigned  bbr;    // right
   unsigned  bbm;    // mid-base
   unsigned  bbh;    // height
   unsigned  bbd;    // depth

   // slanted box.   bbstl<bbstr ^ bbsdl<bbsdr 
   bool      slantFlag;
   unsigned  bbstl;  // top left
   unsigned  bbstr;  // top right
   unsigned  bbsdl;  // bottom left
   unsigned  bbsdr;  // bottom right

   //////////////////////
   // Spacing
   int       dy;  // +/- relative base

   // spacing to the left

   // extra sentence space (most left)
   bool  extSpcFlag;
   unsigned  extSpcLeft;     
   // unsigned  extSpcRight; == leftStretch
   unsigned  extSpcTop; // < bbm

   // strach <-> shrink left (increasing order)
   unsigned  leftStretch; 
   unsigned  leftSpace;
   unsigned  leftShrink;

   // spacing to the right
   unsigned  itCor; // bbr + x(cItalic)

   // shrink <-> stretch right (increasing order)
   unsigned  rightShrink;
   unsigned  rightSpace;
   unsigned  rightStretch;

   // ex + em
   unsigned  ex;   
   unsigned  exTop;   // bbm - ex
   unsigned  em;
   unsigned  emRight; // bbl + em

   // raster offset
   unsigned  xoff;
   unsigned  yoff;

}; // FocusCharPixels


#endif /* fOcUschArpIxEls */
