// $Id: bignum.c,v 1.2 1997/03/25 10:18:43 yotam Exp $
#include <Integer.h>
#include "debug.h"

typedef unsigned long  UL;


////////////////////////////////////////////////////////////////////////
UL 
n1n2dn3(UL n1, UL n2, UL d)
{
   Integer  i1(n1);
   Integer  i2(n2);
   Integer  id(d);
   Integer  ir = (i1 * i2) / id;
   long     l = ir.as_long();
   UL r = (UL)l;
   return(r);
} // n1n2dn3


////////////////////////////////////////////////////////////////////////
UL 
n1n2n3_div2p(UL n1, UL n2, UL n3, unsigned p)
{
   Integer  i1(n1);
   Integer  i2(n2);
   Integer  i3(n3);
   Integer  i123 = i1 * i2 * i3;

   DPR0("i1=" << hex << i1 << ", i2=" << i2 << ", i3=" << i3 << ", p=" << p);

   Integer  twoPm1(1);
   DPR0("i123=" << i123);
   i123 += twoPm1;  // add half of the divisor fpr rounding
   DPR0("(i123 + d/2) = " << i123);

   // Integer  ir = i123 / twoP;
   Integer  ir;
   rshift(i123, p, ir);
   long     l = ir.as_long();
   UL r = (UL)l;

   DPR0("ir=" << ir << ", r=" << r << dec);
   return(r);
} // n1n2n3_div2p


////////////////////////////////////////////////////////////////////////
UL 
n1n2n3n4_div2p(UL n1, UL n2, UL n3, UL n4, unsigned p)
{
   Integer  i1(n1);
   Integer  i2(n2);
   Integer  i3(n3);
   Integer  i4(n4);
   Integer  i1234 = i1 * i2 * i3 * i4;

   DPR0("i1=" << hex << i1 << ", i2=" << i2 << ", i3=" << i3 << ", i4=" << i4 <<
        ", p=" << p);

   Integer  twoPm1(1);
   DPR0("i1234=" << i1234);
   i1234 += twoPm1;  // add half of the divisor fpr rounding
   DPR0("(i1234 + d/2) = " << i1234);

   // Integer  ir = i1234 / twoP;
   Integer  ir;
   rshift(i1234, p, ir);
   long     l = ir.as_long();
   UL r = (UL)l;

   DPR0("ir=" << ir << ", r=" << r << dec);
   return(r);
} // n1n2n3n4_div2p


#if defined(TEST)
int
main(int, char **)
{
    while (!cin.fail())
    {
       UL  n1, n2, d;
       cerr << "Enter n1 n2 d" << endl;
       cin >> n1 >> n2 >> d;
       UL  r = n1n2dn3(n1, n2, d);
       cout << "(" << n1 << " * " << n2 << ") / " << d << " = " << r << endl;
    }
    return(0);
} // main
#endif
