// $Id: block.h,v 1.5 1997/07/01 05:37:45 yotam Exp $
#ifndef _blOck
#define _blOck

#include <BitSet.h>
#include "baseint.h"
#include "bitmap.h"


class TfmpkProgBlock
{
 public: // it's main, gimme a break from security

   int                 cmd(int argc, char** argv);

   // of main
   int                 argc;
   char**              argv;

   class XWinInfo*     xwinfo;
   struct Tcl_Interp*  interp;
   class TeXtfm*       pTFM;
   class TeXpk*        pPK;
   class TkInfo*       pTk;

   // TFM+PK files loaded successfully
   bool               fontLoaded() const;

   // pixel font/screen parameters
   US16               pixelFontPerScreenNominator,
                      pixelFontPerScreenDenominator,
                      // pixelFontPerScreenSquareThreshold,
                      pixelZoomScreenPerFont;
   unsigned           pixelTableMult(unsigned x) const;

   // Table pixel fill sizes
   US16               chfill, 
                      cvfill,
                      thfill, 
                      tvfill;

   TfmpkProgBlock();
   ~TfmpkProgBlock();

   bool  copyArgs(int ac, const char*  const* av);
   // void  setPixelRatios(const char*  const* argv);
   
   // simple PK calls
   bool  openPk(const char*  const* argv);

   // dimensions resulted from loading PK-file
   US8   charFirst() const;
   US8   charLast()  const;
   enum  {Left, Right, Up, Down, Nlrud};    
   US32  maxRef(US8 lrud) const; 
         // { return _maxRef[lrud];} // bitmap references 

   // and also depending user preferences...
   US32   winWidth() const { return _winWidth;};
   US32   winHeight() const { return _winHeight;};

   // draw font-table
   void drawFontTable();

   // draw picked char
   bool  focusCharWinSize();
   bool  focusCharProbe(const char* const*  const argv);
   int   configureFocusChar();
   void  focusBitmapUpdate();
   void  drawFocusChar();

   // pick a character from the font-table
   int  pickChar(int argc, const char*  const*  const argv);
   US8  pickedChar() const {return _pickedChar;};

   // more involved PK calls
   int  pkShow(const char* canvasName); 

   // multi-function tfm info 
   bool  tfmInfo(int argc, const char*  const*  const argv);

   bool  pkCharInfo(int argc, const char*  const*  const argv);
   bool  pkGeneral();

   // kern-Show 
   bool  kernShow(int argc, const char*  const*  const argv);
   void  kernShowDraw();
   void  kernShowBitmapUpdate();
   bool  kernShowSet(int argc, const char*  const*  const argv);
   bool  kernShowWinSize();

   // extensible-recipe show
   unsigned  extenIndex;
   unsigned  extenKVal;
   bool  extenShow(int argc, const char*  const*  const argv);
   void  extenShowDraw();
   void  extenShowBitmapUpdate();
   bool  extenShowWinSize();
   
   // set preference
   bool  setPreference(int argc, const char*  const*  const argv);

   // update internal sizes.
   // sets the pixelFontPerScreen<Nom|Denom>inator
   bool  fitZoomTable(const char* const* argv);

   // update internal sizes.
   void  tableDims(); 

   bool  select(US8 c) const;
   void  select(US8 c, bool b);
   void  deselectAllChars();

   
 private:
   void  deleteHide(); // Alas, this one will know about sub strcutures.
   void  updateBitmaps();
   bool  setFocusCharPixels();

   US32       _winWidth;   
   US32       _winHeight;   

   US8        _pickedChar;
   Bitmap     _bitmapFocus;
   bool       _bitmapFocusDirty;
   bool       _focusGrid;

   Bitmap     _bitmap[256]; // used when magnifying fraction
   bool       _dirtyBitmap;

   // dispaying the kerned pair
   Bitmap     _kernBitmap[2];
   bool       _kernBitmapDirty;
   Int32      _kernShowIndex;
   US32       _kernShowOwnerIndex; // kern may belong to several, so
   bool       _kernShowKernOn;

   // dispaying extensible char
   bool       _extenBitmapDirty;
   Bitmap     _extenTMBRBitmap[4]; // {top,mid,bot,rep}
   bool       _extenShowOn;

   BitSet     _selectedChar;
   unsigned   _pad;     // boundary pad for display
}; // TfmpkProgBlock


// Becaues 
#endif /* _blOck */
