// $Id: cmd.c,v 1.3 1997/07/25 05:44:30 yotam Exp yotam $
// # include <ctype.h>
# include <string>
# include <stdlib.h>
# include <string.h>
// # include <unistd.h>
#include <iostream.h>
#include <strstream.h>
#include <tk.h>

#include "baseint.h"
#include "block.h"
#include "xwin.h"
#include "lspath.h"
#include "tcltool.h"
#include "textfm.h"
#include "tkinfo.h"
#include "ximple.h"
#include "debug.h"


////////////////////////////////////////////////////////////////////////
int
TfmpkProgBlock::cmd(int  argc, char** argv)
{
   int  i, rc = TCL_OK;

   DASSERT(argc >= 2 && !strcmp(argv[0], "tfmpk"));
   DPR0("argc=" << argc << endl);
   for (i = 0;  i < argc;  i++)
   {
      DPR0("argv[" << i << "]=" << argv[i] << endl);
   }

   interp->result[0] = '\0';  // By default empty
   ostrstream   result(interp->result, TCL_RESULT_SIZE - 1);

   if (!strcmp(argv[1], "init"))
   {
      if (!copyArgs(argc, argv))
      {
         cerr << "TFMPK: initialization failed" << endl;
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "extenShow"))
   {
      DASSERT(argc == 4); // tfmpk extenShowWinSize ei k
      if (!extenShow(argc - 2, argv + 2))
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "extenShowWinSize"))
   {
      DASSERT(argc == 2); // tfmpk extenShowWinSize
      if (!extenShowWinSize())
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "focusCharGrid"))
   {
      DASSERT(argc == 3); // tfmpk focusCharGrid [0/1]
      _focusGrid = (bool)atoi(argv[2]);
   }
   else if (!strcmp(argv[1], "focusCharWinSize"))
   {
      DASSERT(argc == 2); // tfmpk focusCharWinSize
      if (!focusCharWinSize())
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "focusCharProbe"))
   {
      DASSERT(argc == 4); // tfmpk focusCharProbe <x> <y>
      if (!focusCharProbe(argv + 2))
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "kernShow"))
   {
      DASSERT(argc == 5); // tfmpk kernShow <ligkernIndex> <ownerIndex> <on>
      if (!kernShow(argc - 2, argv+2))
      {
         result << "Failed to set kernShow patameters" << ends;
      }
   }
   else if (!strcmp(argv[1], "loadPK"))
   {
      DASSERT(argc == 4); // tfmpk loadPK <pkfile> <flags>
      if (!openPk(argv+2))
      {
         result << "Failed to load PK-file '" <<  argv[2] << "'" << ends;
      }
   }
   else if (!strcmp(argv[1], "loadTFM"))
   {
      DASSERT(argc == 4); // tfmpk loadTFM <pkfile> <flags>
      if (pTFM)
      {
         delete pTFM;
      }
      pTFM = new TeXtfm(argv[2], (US32)atol(argv[3]));
      if ((pTFM == 0) || !(pTFM->active()))
      {
         result << "Failed to load TFM-file '" <<  argv[2] << "'" << ends;
      }
      else
      {
         _kernShowIndex = -1;   _kernShowOwnerIndex = 0;
      }
   }
   else if (!strcmp(argv[1], "kernShowWinSize"))
   {
      DASSERT(argc == 2); // tfmpk kernShowWinSize
      if (!kernShowWinSize())
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "matchFonts"))
   {
      DASSERT(argc >= 4);
      // 0     1          2        3      4       5    6   7++ 
      // tfmpk matchFonts fontlist pkList tfmList #tfm #pk <tfmList> <pkList>
      string  fpt[3];
      // 0     1          2    3   4++
      // tfmpk matchFonts #tfm #pk <tfmList> <pkList>
      extern bool matchFonts(ostream&, int, int, int, const char* const*);
      ostrstream  ostr3lists;
      int  nTfm = atoi(argv[2]);
      int  nPk  = atoi(argv[3]);
      int  nListArgs = argc - 4;
      if ((nTfm + nPk == nListArgs) &&
          matchFonts(ostr3lists, nTfm, nPk, nListArgs, argv + 4))
      {
         ostr3lists << ends;
         setTclResult(interp, ostr3lists);
      }
      else
      {
         rc = TCL_ERROR;
         result << "matchFonts failed" << ends;
      }
   }
   else if (!strcmp(argv[1], "pickChar"))
   {
      DASSERT(2 <= argc && argc <= 4); // tfmpk pickChar [<%c> | <%x> <%y>]
      if ((argc != 2) && !pickChar(argc - 2, argv + 2))
      {
         rc = TCL_ERROR;
      }
      result << (int)(pickedChar()) << ends;

   }
#if 0
   else if (!strcmp(argv[1], "pixelRatios"))
   {
      DASSERT(argc == 2 + 4)
      setPixelRatios(argv + 2);
   }
#endif
   else if (!strcmp(argv[1], "pkCharInfo"))
   {
      DASSERT(argc == 3); // tfmpk pkCharInfo c
      if (!pkCharInfo(argc - 2, argv + 2))
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "pkGeneral"))
   {
      if (!pkGeneral())
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "pref"))
   {
      if (!setPreference(argc - 2, argv + 2))
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "tableWinSize"))
   {
      DASSERT(argc == 5); // tfmpk tableWinSize maxGeo hintNom hintDenom
      // tableDims();
      fitZoomTable(argv + 2);
      result << winWidth() << ' ' << winHeight() << ' ' << 
                pixelFontPerScreenNominator << ' ' << 
                pixelFontPerScreenDenominator << ends;
   }
   else if (!strcmp(argv[1], "tfminfo"))
   {
      if (!tfmInfo(argc - 2, argv + 2))
      {
         rc = TCL_ERROR;
      }
   }
   else if (!strcmp(argv[1], "winit"))
   {
      DASSERT(argc == 2); // tfmpk winit 
      xwinfo = new XWinInfo(interp);
   }
   else
   {
      rc = TCL_ERROR;
   } 
   return(rc);   
} // tfmpkCmd
