// $Id: debug.c,v 1.2 1997/03/25 10:18:43 yotam Exp $
#if DEBUG

#include <fstream.h>
#include <string.h>
#include <pwd.h>
#include <unistd.h>
#include <sys/stat.h>

#include <iostream.h>


////////////////////////////////////////////////////////////////////////
// To be called mostly once
static const char *
makeWaitFileName()
{
   const char  *head   = "/tmp/";     int lHead = strlen(head);

   uid_t       myUid = getuid();
   struct passwd *mypwd = getpwuid(myUid);
   // const char  *pLogin = getlogin();  int lPlog = strlen(pLogin);
   const char  *pLogin = mypwd->pw_name;  int lPlog = strlen(pLogin);

   const char  *tail   = ".wait";    int lRail = strlen(tail);
   unsigned    l = lHead + lPlog + lRail;
   char        *waitfn = new char[l + 1];
   (void)strcpy(waitfn, head);
   (void)strcpy(waitfn + lHead, pLogin);
   (void)strcpy(waitfn + lHead + lPlog, tail);
   return(waitfn);
} // makeWaitFileName


////////////////////////////////////////////////////////////////////////
void
waitOnFile(unsigned maxSleep)
{
   // static const char *waitfn = "/tmp/yotam.wait";
   static const char *waitfn = makeWaitFileName();
   struct stat  statbuf;
   time_t       oldtime;
   unsigned     slept = 0;

   cerr <<  "Process " << getpid() << " will wait until you touch " << 
	    waitfn << " or give up after " << maxSleep << " seconds." << endl;
                   
   stat(waitfn, &statbuf);
   oldtime = statbuf.st_mtime;
   while (statbuf.st_mtime == oldtime && slept < maxSleep)
   {
      sleep(1);  slept++;
      stat(waitfn, &statbuf);
   }
   cerr << "Sensed or gave up -  and continue..." << endl;
} /* waitOnFile */

#endif


