// $Id: fintval.h,v 1.2 1995/10/01 22:20:44 yotam Exp $
// File integer values interface
#ifndef _fIntvAl
#define _fIntvAl

#include <fstream.h>
#include "baseint.h"

class BifStream : public ifstream
{

private:
   US8  savedByte;             // For extracting bits
   int  nBitsCashed;           // 0 means savedByte invalid.

public:

   // Constructors
   BifStream() {};
   BifStream(int fd): ifstream(fd) {};
   BifStream(const char *fn): ifstream(fn, 
                                       ios::in | ios::nocreate | ios::bin, 
                                       0) {};


   Int8    get1byte();
   US8     get1ubyte();

   Int16   get2byte();
   US16    get2ubyte();

   Int32   get3byte();
   US32    get3ubyte();

   Int32   get4byte();
   US32    get4ubyte();

   void    bitscanFlush(); 
   US8     get4bits();

   US8     getByteBits(US8 nBits);  //  0 < nBits <= 8
   US32    getWordBits(US8 nBits);  //  0 < nbits <= 32
}; // BifStream

#endif /* _fIntvAl */
