#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <algorithm>
#include <list>
#include "newdel.h"
#include "debug.h"

// Each allocated pointer for the applicatipon
// will have an extra 5 words.
// 4 will be used in the beginning and 1 in the end.
//
//        "Real" new-ed pointer -> +0    funk (magic)
//        size                     +1    n
//        Previous-pointer         +2
//        Next-pointer             +3
//        Application-pointer      +4
//              ....
//                                 +4+n  off (magic)

bool   ymCheckMem = false;

static const char*  funk = "fu*k";
static const char*  off  = "off";
static const int    nExtraBytesPre = 4 + sizeof(size_t) + 2*sizeof(void*);
static const int    nExtraBytes = nExtraBytesPre + 4;
static const int    offsetPrev = 4 + sizeof(size_t);
static const int    offsetNext = 4 + sizeof(size_t) + sizeof(void*);

static void*   headNews;  // points to application

#define newdelAssert(p)          \
        {                        \
           bool b = ymCheckMem;  \
           ymCheckMem = false;   \
           DASSERT(p);           \
           ymCheckMem = b;       \
        }

////////////////////////////////////////////////////////////////////////
static int
dirtyStack()
{
   char  cz = 'z';
   char  ac[7991];
   char  ca = 'a';
   for (int  i = sizeof(ac);  i--;  ac[i] = 0xfc);
   return(ca + cz + ac[13]);
} // dirtyStack


////////////////////////////////////////////////////////////////////////
int  YMCHECKMEM::_cntr = 0;

////////////////////////////////////////////////////////////////////////
YMCHECKMEM::YMCHECKMEM()
{
   if (_cntr == 0)
   {
      ymCheckMem = true;
      dirtyStack();
   }
   _cntr++;
} // YMCHECKMEM::YMCHECKMEM


////////////////////////////////////////////////////////////////////////
YMCHECKMEM::~YMCHECKMEM()
{
   _cntr--;
   if (_cntr == 0)
   {
      ymCheckMem = false;
      unsigned  nn = ymCheckNews();
      DASSERT(nn == 0);
   }
} // YMCHECKNEWS::~YMCHECKNEWS


////////////////////////////////////////////////////////////////////////
static void
memCpyGo(void* to, const char*& from, size_t nBytes)
{
   memcpy(to, from, nBytes);
   from += nBytes;
} // memcpygo


////////////////////////////////////////////////////////////////////////
static void
goMemCpy(char*& to, const void* from, size_t nBytes)
{
   memcpy(to, from, nBytes);
   to += nBytes;
} // memcpygo


////////////////////////////////////////////////////////////////////////
void
validPtr(const void* pvMalloc)
{
   const char*  pMalloc = (const char*)pvMalloc;
   const char*  pc = pMalloc;
   size_t  n;
   void*  prev;
   void*  next;
   pc += 4; // skip funk
   memCpyGo(&n,    pc, sizeof(size_t));
   memCpyGo(&prev, pc, sizeof(void*));
   memCpyGo(&next, pc, sizeof(void*));
   newdelAssert((prev == 0) == (pMalloc == headNews));
   if (prev != 0)
   {
      void**  prevNext = (void**)(((char*)prev) + offsetNext);
      newdelAssert(*prevNext == pMalloc);
   }
   if (next != 0)
   {
      void**  nextPrev = (void**)(((char*)next) + offsetPrev);
      newdelAssert(*nextPrev == pMalloc);
   }
} // validptr


////////////////////////////////////////////////////////////////////////
unsigned
ymCheckNews(const void* lookfor = 0)
{
   bool         ok = true;
   unsigned     nNews = 0;
   bool         found = (lookfor == 0);
   const void*  pl = headNews;
   const void*  last = 0;
   while (ok && (pl != 0))
   {
      found = found || (lookfor == pl);
      const char*   pc = (char*)pl;
      ok = (strncmp(pc, funk, 4) == 0) && ok;   newdelAssert(ok);
      pc += 4;
      unsigned  n;
      memCpyGo(&n, pc, sizeof(size_t));
      const void*  prev;
      const void*  next;
      memCpyGo(&prev, pc, sizeof(void*));
      ok = (prev == last);                      newdelAssert(ok);
      memCpyGo(&next, pc, sizeof(void*));
      pc += n;
      ok = (strcmp(pc, off) == 0) && ok;        newdelAssert(ok);
      last = pl;
      pl = next;
      nNews++;
   }
   newdelAssert(found);
   return(nNews);
} // ymCheckNews


////////////////////////////////////////////////////////////////////////
static void*
mynew(size_t n)
{
   size_t                 na = n;
   if (ymCheckMem)
   {
      // ymCheckNews();
      na += nExtraBytes;
   }
   char*                  p = (char*)malloc(na);
   void*                  pMalloc = p;
   if (ymCheckMem)
   {
      static const void*  pNull = 0;
      goMemCpy(p, funk, 4);
      goMemCpy(p, &n, sizeof(size_t));
      goMemCpy(p, &pNull, sizeof(void*));
      goMemCpy(p, &headNews, sizeof(void*));
      if (headNews != 0)
      {
         void**  headPrev = (void**)(((char*)headNews) + offsetPrev);
         newdelAssert(*headPrev == 0);
         *headPrev = pMalloc;
      }
      headNews = pMalloc;
   }
   void*  appPtr = p;
   if (ymCheckMem)
   {
      strcpy(p + n, off);
      for (int  i = n;  i--;  p[i] = (char)0xfd);
      // ymCheckNews(pMalloc);
      validPtr(pMalloc);
   }
   return(appPtr);
} // mynew


////////////////////////////////////////////////////////////////////////
static void
mydel(void* appPtr)
{
   char*  pc = (char*)appPtr;
   char*  pFree = pc;
   if (ymCheckMem)
   {
      pc -= nExtraBytesPre;
      pFree = pc;
      // ymCheckNews(pFree);
      validPtr(pFree);
      size_t  n;
      void*  prev;
      void*  next;
      pc += 4; // skip funk
      memCpyGo(&n,    pc, sizeof(size_t));
      memCpyGo(&prev, pc, sizeof(void*));
      memCpyGo(&next, pc, sizeof(void*));
      newdelAssert((prev == 0) == (pFree == headNews));
      if (prev != 0)
      {
         void**  prevNext = (void**)(((char*)prev) + offsetNext);
         newdelAssert(*prevNext == pFree);
         *prevNext = next;
      }
      else
      {
         headNews = next;
      }
      if (next != 0)
      {
         void**  nextPrev = (void**)(((char*)next) + offsetPrev);
         newdelAssert(*nextPrev == pFree);
         *nextPrev = prev;
      }

      for (int i = n + nExtraBytes;  i--;  pFree[i] = 0xfe); // dirty it
      // ymCheckNews();
   }
   free(pFree);
} // mydel


////////////////////////////////////////////////////////////////////////
void *operator new (size_t n)
{
   return mynew(n);
} // new


////////////////////////////////////////////////////////////////////////
void *operator new[] (size_t n)
{
   return mynew(n);
} // new []


////////////////////////////////////////////////////////////////////////
void operator delete (void * p)
{
   mydel(p);
} // delete


////////////////////////////////////////////////////////////////////////
void operator delete[] (void * p)
{
   mydel(p);
} // delete []
