// $Id: ximple.h,v 1.2 1997/07/11 05:06:00 yotam Exp $
#ifndef xImplE
#define xImplE

// ximple is a Tk widget, that creates a simple X window
// to be drawn and updated only by the application via direct Xlib calls.
// The application can hook the display function depnding on the
// instantiation of teh widget.

#include <iostream.h>
#include <tk.h>

// 
typedef  void (XimpleDrawFunc)(Tk_Window tkwin, ClientData appData);
typedef  int  (XimpleCustomConfigFunc)(Tk_Window tkwin, ClientData appData);
typedef  void (XimpleDestroyFunc)(Tk_Window tkwin, ClientData appData);

// a client function assigning a Drawing function with an opaque data
// to a widget given its instantiation arguments.
typedef  int   (XimpleAssignFuncs)
(             // output
   ostream                   &  result,
   XimpleDrawFunc            *& drawFunc,
   XimpleCustomConfigFunc    *& custConfFunc,
   XimpleDestroyFunc         *& destroyFunc,
   ClientData                &  appData,
              // input
   Tcl_Interp                *  interp, 
   Tk_Window                    tkwin,
   int                          argc,
   char                      ** argv,
   ClientData                   assignData
);


// The Ximple package initialization. 
// Since  different instances of Ximple widget may need different 
// drawing, custom-configuring, destroying - function, 
// The application should be flexiable to assign them upon instantiation.
extern int
Ximple_Init
(
   Tcl_Interp          *intertp, 
   XimpleAssignFuncs   *assignFuncs,  
   ClientData          assignData,       // to be passed with assignFuncs.
   const Tk_ConfigSpec *customConfigSpec // array appended to the standard.
                                         // if !=0, must end with TK_CONFIG_END
);

#endif /* xImplE */
