// $Id: xwin.h,v 1.3 1997/07/25 05:44:30 yotam Exp yotam $
#ifndef _xwIn
#define _xwIn

#include <string>
#include <X11/Xlib.h> 
#include <tcl.h> 
#include <tk.h> 

class FocusCharPixels;

class XWinInfo
{
 public:
   XWinInfo(Tcl_Interp* interp);
   virtual ~XWinInfo();

   enum GCindex  {Clear, Raster, Border, Text, Select, Ascend, Ngc};
   GC            gc(unsigned int gci) const {return _gc[gci];};
   bool          setColorGC(const char *item, const char *colorSpec);
   void          setBackingStore(Tk_Window  tkwin) const;

   FocusCharPixels*  focusCharPixels() {return _focusCharPixels;}

 private:
   static const char *ColorOptionName[Ngc];  

   // unsigned long     colorFor(GCindex, const char* colorOption);

   Tcl_Interp*       _interp;
   Display*          _dpy;
   Tk_Window         _someWin;
   FocusCharPixels*  _focusCharPixels;
   GC                _gc[Ngc];
   XColor*           _xColor[Ngc];
   string            _colorSpec[Ngc];

   // Not available
   XWinInfo();
   XWinInfo(const XWinInfo&);
   XWinInfo operator=(const XWinInfo&);
}; // XWinInfo

// #include "baseint.h"
// extern inttfmpkTkResizeCheck(Tk_Window tkwin, US32 width, US32 height);


#endif /* _xwIn */
